Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.sort
Class SortedIterator

    java.lang.Object
      net.sf.saxon.sort.SortedIterator

All Implemented Interfaces:
  LastPositionFinder, SequenceIterator, Sortable

Direct Known Subclasses:
  SortedGroupIterator

public class SortedIterator
extends java.lang.Object
implements SequenceIterator, LastPositionFinder, Sortable

Class to do a sorted iteration

Field Summary
`protected SequenceIterator` | `base`
`protected XPathContext` | `context`
`protected int` | `count`
`protected int` | `index`
`protected java.lang.Object[]` | `nodeKeys`
`protected int` | `recordSize`
`protected FixedSortKeyDefinition[]` | `sortkeys`

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`ATOMIZABLE, GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`SortedIterator(XPathContext context, SequenceIterator base, FixedSortKeyDefinition[] sortkeys)`

Method Summary
`protected void` | `buildArray()`
`int` | `compare(int a, int b)` Compare two items in sorted sequence (needed to implement the Sortable interface)
`Item` | `current()` Get the current value in the sequence (the one returned by the most recent call on next()).
`SequenceIterator` | `getAnother()` Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.
`int` | `getLastPosition()` Get the last position (that is, the number of items in the sequence).
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`Item` | `next()` Get the next item, in sorted order
`int` | `position()` Get the current position.
`void` | `setHostLanguage(int language)`
`void` | `swap(int a, int b)` Swap two items (needed to implement the Sortable interface)

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### base

    protected SequenceIterator base

### sortkeys

    protected FixedSortKeyDefinition[] sortkeys

### recordSize

    protected int recordSize

### nodeKeys

    protected java.lang.Object[] nodeKeys

### count

    protected int count

### index

    protected int index

### context

    protected XPathContext context

Constructor Detail

### SortedIterator

    public SortedIterator(XPathContext context,
                          SequenceIterator base,
                          FixedSortKeyDefinition[] sortkeys)

Method Detail

### setHostLanguage

    public void setHostLanguage(int language)

### next

    public Item next()
              throws XPathException

  Get the next item, in sorted order

  Specified by:
    `next` in interface `SequenceIterator`
  Returns:
    the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
  Throws:
    `XPathException` - if an error occurs retrieving the next item

### current

    public Item current()

  Description copied from interface: `SequenceIterator`
  Get the current value in the sequence (the one returned by the most recent call on next()). This will be null before the first call of next(). This method does not change the state of the iterator.

  Specified by:
    `current` in interface `SequenceIterator`
  Returns:
    the current item, the one most recently returned by a call on next(). Returns null if next() has not been called, or if the end of the sequence has been reached.

### position

    public int position()

  Description copied from interface: `SequenceIterator`
  Get the current position. This will usually be zero before the first call on next(), otherwise it will be the number of times that next() has been called. Once next() has returned null, the preferred action is for subsequent calls on position() to return -1, but not all existing implementations follow this practice. (In particular, the EmptyIterator is stateless, and always returns 0 as the value of position(), whether or not next() has been called.)

  This method does not change the state of the iterator.

  Specified by:
    `position` in interface `SequenceIterator`
  Returns:
    the current position, the position of the item returned by the most recent call of next(). This is 1 after next() has been successfully called once, 2 after it has been called twice, and so on. If next() has never been called, the method returns zero. If the end of the sequence has been reached, the value returned will always be <= 0; the preferred value is -1.

### getLastPosition

    public int getLastPosition()
                        throws XPathException

  Description copied from interface: `LastPositionFinder`
  Get the last position (that is, the number of items in the sequence). This method is non-destructive: it does not change the state of the iterator. The result is undefined if the next() method of the iterator has already returned null. This method must not be called unless the result of getProperties() on the iterator includes the bit setting `SequenceIterator.LAST_POSITION_FINDER`

  Specified by:
    `getLastPosition` in interface `LastPositionFinder`
  Throws:
    `XPathException`

### getAnother

    public SequenceIterator getAnother()
                                throws XPathException

  Description copied from interface: `SequenceIterator`
  Get another SequenceIterator that iterates over the same items as the original, but which is repositioned at the start of the sequence.

  This method allows access to all the items in the sequence without disturbing the current position of the iterator. Internally, its main use is in evaluating the last() function.

  This method does not change the state of the iterator.

  Specified by:
    `getAnother` in interface `SequenceIterator`
  Returns:
    a SequenceIterator that iterates over the same items, positioned before the first item
  Throws:
    `XPathException` - if any error occurs

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `GROUNDED`, `LAST_POSITION_FINDER`, and `LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

### buildArray

    protected void buildArray()
                       throws XPathException

  Throws:
    `XPathException`

### compare

    public int compare(int a,
                       int b)

  Compare two items in sorted sequence (needed to implement the Sortable interface)

  Specified by:
    `compare` in interface `Sortable`
  Returns:
    <0 if obj[a]0 if obj[a]>obj[b]

### swap

    public void swap(int a,
                     int b)

  Swap two items (needed to implement the Sortable interface)

  Specified by:
    `swap` in interface `Sortable`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD